<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }

class router
{
    Private $Reg;
    private $routebase = 0;
    private $allowed_routes = array();
    private $base_controller = "members";
    private $base_method = "index";

    public function __construct($Registry){
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","Router Class");
    }

    public function route($controller = null, $method = null,$search=true)
    {

        $cur_controller = $this->base_controller;
        $cur_method = $this->base_method;

        if($controller)
        {
            $cur_controller = $this->Reg->security->sanitise($controller);
        }
        if($method)
        {
            $cur_method = $this->Reg->security->sanitise($method);
        }

        if($search)
        {
            $requestURI = explode('/', $_SERVER['REQUEST_URI']);

            foreach($requestURI as $key => $value ){
                if($value == "admin.php"){ $this->routebase = $key; break; }
            }

            $controllerkey = $this->routebase + 1;
            if(isset($requestURI[$controllerkey])){
                $cur_controller = $this->Reg->security->sanitise($requestURI[$controllerkey]);
            }
            $methodkey = $this->routebase + 2;
            if(isset($requestURI[$methodkey])){
                $cur_method = $this->Reg->security->sanitise($requestURI[$methodkey]);
            }
            $methodkey = $this->routebase + 3;
            if(isset($requestURI[$methodkey])){
                $this->Reg->settings->ConfSet("request1",$this->Reg->security->sanitise($requestURI[$methodkey]));
            }

        }


        $this->Reg->log->log("controller_called",$cur_controller);
        $this->Reg->log->log("method_called",$cur_method);


        if(isset($this->allowed_routes[$cur_controller])){
            foreach($this->allowed_routes[$cur_controller] as $key => $value){
                if($value == $cur_method){
                    $this->Reg->$cur_controller->$cur_method();
                    exit;
                }
            }
        }
        $this->Reg->tpl->show404();
    }

    public function home($redirect=false)
    {

        if($redirect)
        {
          $site_url = $this->Reg->settings->Config("site_url")."/admin.php";
            header("Location: $site_url");
            exit;
        }
       $this->route('','',false);
    }

    public function set_route($route,$methods=null)
    {
        if($route == "") { return; }
        if(!isset($this->allowed_routes[$route])){
        $this->allowed_routes[$route] = array();
        }
        if($methods != ""){
        $this->set_methods($methods,$route);
        }
        return;
    }

    public function set_methods($method, $route)
    {
        if($route == ""){ return; }
        if(is_array($method)){
            foreach($method as $key => $value){
                if($value != ""){
                    array_push($this->allowed_routes[$route], $value);
                }
            }
        }
        return;
    }
}
